﻿package com{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
	public class Main extends MovieClip{
		
		private var currRange:Number = 0;
		private var rangeArr = ["0_20", "0_99", "100_999"];
		private var randNum:Number = 0;
		
		public function Main(){
			addBtnListeners();
		}
		
		private function addBtnListeners(){
			for(var i=1; i<=3; i++){
				var RangeBtn = this["rangeBtn"+i];
				RangeBtn.Num = i;
				RangeBtn.buttonMode = true;
				RangeBtn.addEventListener(MouseEvent.CLICK, selectRangeFunc);
				RangeBtn.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
				RangeBtn.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
				RangeBtn.mouseChildren = false;
			}
			flipBtn.buttonMode = true;
			flipBtn.addEventListener(MouseEvent.CLICK, flipFunc);
			flipBtn.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			flipBtn.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			cardsMc.buttonMode = true;
			cardsMc.addEventListener(MouseEvent.CLICK, flipFunc);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		
		private function onBtnOver(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(2);
		}
		
		private function onBtnOut(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(1);
		}
		
		private function onReset(obj:MouseEvent){
			currRange = 0;
			var RangeBtn = this["rangeBtn"+1];
			RangeBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			flipBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		
		private function flipFunc(obj:MouseEvent){
			var rangeNum = rangeArr[currRange-1].split("_");
			var startNum = Number(rangeNum[0]);
			var endNum = Number(rangeNum[1]);
			randNum = Math.round(Math.random()*(endNum-startNum))+startNum;
			flipMc.myTxt.text = randNum;
		}
		
		private function selectRangeFunc(obj:MouseEvent){
			for(var i=1; i<=3; i++){
				var RangeBtn = this["rangeBtn"+i];
				RangeBtn.mouseEnabled = true;
				RangeBtn.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
				RangeBtn.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
				RangeBtn.gotoAndStop(1);
			}
			currRange = obj.currentTarget.Num;
			RangeBtn = this["rangeBtn"+currRange];
			RangeBtn.removeEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			RangeBtn.removeEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			RangeBtn.mouseEnabled = false;
			RangeBtn.gotoAndStop(3);
	
		}
	}
}