﻿package com{
	
	import flash.display.MovieClip;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getDefinitionByName;
	
	public class extendedNotationDragDrop extends MovieClip{
		
		private var stageWidth:Number = 760;
		private var notations_mc:MovieClip;
		private var yPos:Number = 362;
		private var xPos:Number = 40;
		private var count:Number = 0;
		private var notationsArr:Array = ["mc_1000_small", "mc_100_small", "mc_10_small", "mc_1_small"];
		private var notationsZero:Array = ["000", "00", "0", ""];
		private var thousands_mc:MovieClip;
		private var hundreds_mc:MovieClip;
		private var tens_mc:MovieClip;
		private var ones_mc:MovieClip;
		private var attachedClip:MovieClip;
		private var notationCnt:Number = 0;
		private var blocksMc:MovieClip;
		private var blocksCnt:Number = 0;
		private var dragObj;
		private var totalNotation:Number = 0;
		
		public function extendedNotationDragDrop():void{			
			randomNo_btn.addEventListener(MouseEvent.CLICK, fnGenerateRandomNo);
			reset_btn.addEventListener(MouseEvent.CLICK, reset);			
			fnGenerateNotations();
			notations_mc = new MovieClip;
			addChild(notations_mc);
			fnAddMovieClipsToStage();
			blocksMc = new MovieClip;
			addChild(blocksMc);
			addBlockListeners();
			tick.visible = false;
		}
		
		private function fnAddMovieClipsToStage():void{			
			thousands_mc = new MovieClip;			
			notations_mc.addChild(thousands_mc);
			thousands_mc.name = "thousands_mc";
			hundreds_mc = new MovieClip;
			notations_mc.addChild(hundreds_mc);
			hundreds_mc.name = "hundreds_mc";
			tens_mc = new MovieClip;
			notations_mc.addChild(tens_mc);
			tens_mc.name = "tens_mc";
			ones_mc = new MovieClip;
			notations_mc.addChild(ones_mc);
			ones_mc.name = "ones_mc";
		}
		
		private function addBlockListeners(){
			for(var i=1; i<=4; i++){
				var myBlock = this["object"+i];
				myBlock.Num = i;
				myBlock.buttonMode = true;
				myBlock.visible = false;
				myBlock.addEventListener(MouseEvent.MOUSE_DOWN, onBlockDown);
			}
			hideMabBtn.visible = false;
			hideMabBtn.buttonMode = true;
			hideMabBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			hideMabBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			hideMabBtn.addEventListener(MouseEvent.CLICK, onBtnClick);
			showMabBtn.buttonMode = true;
			showMabBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnOver);
			showMabBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnOut);
			showMabBtn.addEventListener(MouseEvent.CLICK, onBtnClick);
		}
		
		private function onBtnOver(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(2);
		}
		
		private function onBtnOut(obj:MouseEvent){
			var myBtn = obj.currentTarget;
			myBtn.gotoAndStop(1);
		}
		
		private function onBtnClick(obj:MouseEvent){
			if(showMabBtn.visible == true){
				showMabBtn.visible = false;
				visibleBlocks(true);
				hideMabBtn.visible = true;
			}else{
				showMabBtn.visible = true;
				visibleBlocks(false);
				hideMabBtn.visible = false;
			}
		}
		
		private function visibleBlocks(valU:Boolean){
			for(var i=1; i<=4; i++){
				var myBlock = this["object"+i];
				myBlock.visible = valU;
			}
		}
		
		private function onBlockDown(obj:MouseEvent){
			blocksCnt++;
			var myBlock:MovieClip = duplicateObject(obj.target as MovieClip);
			myBlock.name = "myBlock"+blocksCnt;
			myBlock.Num = blocksCnt;
			myBlock.x = mouseX-(myBlock.width/2);
			myBlock.y = mouseY-(myBlock.height/2);
			blocksMc.addChild(myBlock);
			myBlock.buttonMode = true;
			myBlock.doubleClickEnabled = true;
			myBlock.addEventListener(MouseEvent.DOUBLE_CLICK, removeBlock);
			myBlock.addEventListener(MouseEvent.MOUSE_DOWN, dragBlock);
			myBlock.addEventListener(MouseEvent.MOUSE_UP, dropBlock);
			myBlock.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
		}
		
		private function removeBlock(obj:MouseEvent){
			var myBlock = obj.currentTarget;
			blocksMc.removeChild(myBlock);
			blocksCnt--;
		}
		
		private function dragBlock(obj:MouseEvent){
			dragObj = obj.currentTarget;
			dragObj.startDrag(false, new Rectangle(10, 10, 700, 300));
			dragObj.parent.stage.addEventListener(MouseEvent.MOUSE_UP, dropBlock);
		}
		
		private function dropBlock(obj:MouseEvent){
			dragObj.stopDrag();
			dragObj.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, dropBlock);
		}
		
		private function duplicateObject(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height),true,0x00000000);
			bmd.draw(clone);

			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
		
		private function fnGenerateNotations():void{
			var notationClass:Class;
			var notationClip:MovieClip
			for(var j:Number = 0; j < notationsArr.length; j++){
				for(var i:Number = 1; i <= 9; i++){
					notationClass = getDefinitionByName(notationsArr[j]) as Class;
					notationClip = new notationClass();
					addChild(notationClip);
					notationClip.name = notationsArr[j] + "_" + i;
					notationClip.mouseChildren = false;
					notationClip.x = xPos - notationClip.width/2;
					notationClip.y = yPos;
					xPos = xPos + 78;
					notationClip.txt.text = i + notationsZero[j];
					notationClip.VAL = Number(notationClip.txt.text);
					notationClip.buttonMode = true;
					notationClip.addEventListener(MouseEvent.MOUSE_DOWN, fnAttachBigNotation);
				}
				xPos = 40;
				yPos = yPos + 42;
			}
			var addClip:MovieClip = new add_mc;
			addChild(addClip);
			addClip.x = 725;
			addClip.y = 385;
			addClip.name = "add_mc";
			addClip.buttonMode = true;
			addClip.addEventListener(MouseEvent.MOUSE_DOWN, fnAttachBigNotation);
			var equalClip:MovieClip = new equal_mc;
			addChild(equalClip);
			equalClip.x = 725;
			equalClip.y = 425;
			equalClip.name = "equal_mc";
			equalClip.buttonMode = true;
			equalClip.addEventListener(MouseEvent.MOUSE_DOWN, fnAttachBigNotation);
			totalTxt.restrict = "0-9"
		}
		
		/*private function onMousePress(eve:Event):void{
			for(var i:Number = 0; i < coinsArr.length; i++){
				var clip:MovieClip = coinsMC.getChildByName(coinsArr[i]) as MovieClip
				if (mouseX >= clip.x -(clip.width/2) && mouseX <= clip.x + (clip.width/2) 
					&& mouseY >= clip.y -(clip.height/2) && mouseY<=clip.y+(clip.height/2)) {
					if(draggedClip != null){
						removeChild(draggedClip);
					}
					fnAttachCoin(clip);
				}
			}
		}*/
		
		private function fnAttachBigNotation(eve:MouseEvent):void{
			var clipName:String = eve.target.name;
			var notationClass:Class;
			var notationClip:MovieClip;
			if(notationCnt < 20){
				if(clipName != "add_mc" && clipName != "equal_mc"){
					notationClass = getDefinitionByName(clipName.split("small")[0] + "big") as Class;
					notationClip = new notationClass;
					notationClip.txt.text = eve.target.txt.text;
					notationClip.VAL = eve.target.VAL;
					notationClip.name = clipName.split("small")[0] + "big_" + count;				
					clipName = clipName.split("small")[0];
					if(clipName.split("_")[1] == "1000"){
						thousands_mc.addChild(notationClip);
					}else if(clipName.split("_")[1] == "100"){
						hundreds_mc.addChild(notationClip);
					}else if(clipName.split("_")[1] == "10"){
						tens_mc.addChild(notationClip);
					}else if(clipName.split("_")[1] == "1"){
						ones_mc.addChild(notationClip);
					}
				}else{
					notationClass = getDefinitionByName(clipName) as Class;
					notationClip = new notationClass;
					notations_mc.addChild(notationClip);
					notationClip.name = clipName + "_" + count;
				}
				count++;
				notationCnt++;
				notationClip.buttonMode = true;
				notationClip.mouseChildren = false;
				notationClip.doubleClickEnabled = true;
				notationClip.x = mouseX + notationClip.width/2 ;
				notationClip.y = mouseY - notationClip.height/2;
				/*notationClip.x = mouseX;
				notationClip.y = mouseY;*/
				notationClip.addEventListener(MouseEvent.MOUSE_DOWN, fnDragNotation);
				notationClip.addEventListener(MouseEvent.DOUBLE_CLICK, fnRemoveNotation);
				notationClip.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
			}			
		}
		
		private function fnRemoveNotation(eve:MouseEvent):void{
			var notationClip:MovieClip = eve.target as MovieClip;
			notationCnt--;
			var clipName:String = notationClip.name;
			if(clipName.split("_")[1] == "1000"){
				thousands_mc.removeChild(notationClip);
			}else if(clipName.split("_")[1] == "100"){
				hundreds_mc.removeChild(notationClip);
			}else if(clipName.split("_")[1] == "10"){
				tens_mc.removeChild(notationClip);
			}else if(clipName.split("_")[1] == "1"){
				ones_mc.removeChild(notationClip);
			}
			if(notationClip.name.split("_")[0] != "add" && notationClip.name.split("_")[0] != "equal"){
				//totalNotation = totalNotation-attachedClip.VAL;
			    validateAns();
			}
		}
		
		private function fnDragNotation(eve:MouseEvent):void{		
			/*for(var s:int=notations_mc.numChildren-1;s>=0;s--){
				var parentClip:MovieClip = notations_mc.getChildAt(s) as MovieClip;
				for(var ii:int=parentClip.numChildren-1;ii>=0;ii--){
					var refChildClip:MovieClip = parentClip.getChildAt(ii) as MovieClip;
					/*if(clip.hitTestObject(refChildClip) && clip.name != refChildClip.name){
						//clip.x = clip.dropTarget.parent.x;
						//clip.y = clip.dropTarget.parent.y;
					}*/
					/*if(mouseX <= refChildClip.x && mouseX >= (refChildClip.x - refChildClip.width) && mouseY >= refChildClip.y && mouseY <= (refChildClip.y + refChildClip.height)){
						attachedClip = refChildClip;
						break;
					}
				}
			}*/
			//var clip:MovieClip = eve.target as MovieClip;
			attachedClip = eve.target as MovieClip;
			if(attachedClip.name.split("_")[1] == "1000"){
				thousands_mc.setChildIndex(attachedClip, thousands_mc.numChildren - 1);
			}else if(attachedClip.name.split("_")[1] == "100"){
				hundreds_mc.setChildIndex(attachedClip, hundreds_mc.numChildren - 1);
			}else if(attachedClip.name.split("_")[1] == "10"){
				tens_mc.setChildIndex(attachedClip, tens_mc.numChildren - 1);
			}else if(attachedClip.name.split("_")[1] == "1"){
				ones_mc.setChildIndex(attachedClip, ones_mc.numChildren - 1);
			}
			stage.addEventListener(MouseEvent.MOUSE_MOVE, fnStartDragNotation);
			stage.addEventListener(MouseEvent.MOUSE_UP, fnStopDragNotation);
			
		}
		
		private function fnStartDragNotation(eve:MouseEvent):void{
			//var clip:MovieClip = eve.target as MovieClip;			
			attachedClip.startDrag(false, new Rectangle(10, 10, 740, 460));
			
		}
		
		private function fnStopDragNotation(eve:MouseEvent):void{
			//var clip:MovieClip = eve.currentTarget as MovieClip;
			attachedClip.stopDrag();
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, fnStartDragNotation);
			stage.removeEventListener(MouseEvent.MOUSE_UP, fnStopDragNotation);
			//trace(clip.dropTarget)
			/*if(clip.dropTarget != null){
				clip.x = clip.dropTarget.parent.x;
				clip.y = clip.dropTarget.parent.y;
			}*/
			if(attachedClip.name.split("_")[0] != "add" && attachedClip.name.split("_")[0] != "equal"){
				for(var s:int=notations_mc.numChildren-1;s>=0;s--){
					var parentClip:MovieClip = notations_mc.getChildAt(s) as MovieClip;
					for(var ii:int=parentClip.numChildren-1;ii>=0;ii--){
						var refChildClip:MovieClip = parentClip.getChildAt(ii) as MovieClip;
						/*if(attachedClip.hitTestObject(refChildClip) && attachedClip.name != refChildClip.name){
							attachedClip.x = attachedClip.dropTarget.parent.x;
							attachedClip.y = attachedClip.dropTarget.parent.y;
						}*/
						//checks if edges also touches
						if((mouseX <= refChildClip.x && mouseX >= (refChildClip.x - refChildClip.width) 
							|| (mouseX - attachedClip.mouseX >= (refChildClip.x - refChildClip.width) && mouseX <= refChildClip.x - refChildClip.width)
							|| ((mouseX + attachedClip.mouseX - 20) >= (refChildClip.x - refChildClip.width) && mouseX + attachedClip.mouseX <= refChildClip.x))
							&& (mouseY >= refChildClip.y && mouseY <= (refChildClip.y + refChildClip.height))
							&& attachedClip.name != refChildClip.name){
							//(mouseX <= refChildClip.x && mouseX >= (refChildClip.x - refChildClip.width)
							//|| mouseX + attachedClip.width/2 >= refChildClip.x && mouseX <= refChildClip.x
							//|| (mouseY + attachedClip.height/2 >= refChildClip.y && mouseY <= refChildClip.y)
							//|| (mouseY - attachedClip.height/2 <= refChildClip.y && mouseY >= refChildClip.y)
							attachedClip.x = refChildClip.x;
							attachedClip.y = refChildClip.y;
							/*totalNotation = totalNotation+attachedClip.VAL;
			    			validateAns();*/
							break;
						}
					}
				}
				//totalNotation = totalNotation+attachedClip.VAL;
			    validateAns();
			}
		}
		
		private function validateAns(){
			totalNotation = 0;
			for(var i=1; i<=thousands_mc.numChildren; i++){
				var myClip = thousands_mc.getChildAt(i-1);
				totalNotation = totalNotation+myClip.VAL;
			}
			for(i=1; i<=hundreds_mc.numChildren; i++){
				myClip = hundreds_mc.getChildAt(i-1);
				totalNotation = totalNotation+myClip.VAL;
			}
			for(i=1; i<=tens_mc.numChildren; i++){
				myClip = tens_mc.getChildAt(i-1);
				totalNotation = totalNotation+myClip.VAL;
			}
			for(i=1; i<=ones_mc.numChildren; i++){
				myClip = ones_mc.getChildAt(i-1);
				totalNotation = totalNotation+myClip.VAL;
			}
			trace(totalNotation+"  -----   "+Number(totalTxt.text));
			if(totalNotation==Number(totalTxt.text)){
				tick.visible = true;
			}else{
				tick.visible = false;
			}
		}
		
		private function fnGenerateRandomNo(eve:MouseEvent):void{
			var randomNum:Number = Math.ceil(Math.random() * 9999);
			totalTxt.text = String(randomNum);
			totalTxt.type = TextFieldType.DYNAMIC;
			totalTxt.selectable = false;
			resetAll();
		}
		
		//removes children of reference clip
		private function removeChildOf(clip:*):void{
			for(var i:Number = clip.numChildren-1; i >= 0; i--){
				clip.removeChild(clip.getChildAt(i));
			}
		}
		
		//reset
		private function reset(eve:MouseEvent):void{	
			totalTxt.text = "";
			totalTxt.type = TextFieldType.INPUT;
			totalTxt.selectable = true;
			resetAll();
			totalNotation = 0;
			tick.visible = false;
		}
		
		private function resetAll():void{			
			removeChildOf(thousands_mc);
			removeChildOf(hundreds_mc);
			removeChildOf(tens_mc);
			removeChildOf(ones_mc);
			removeChildOf(notations_mc);
			fnAddMovieClipsToStage();
			count = 0;
			notationCnt = 0;
			while(blocksMc.numChildren){
				blocksMc.removeChildAt(0);
			}
			blocksCnt = 0;
		}
	}
}