﻿package com{
	
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.utils.getDefinitionByName;
	import flash.geom.Rectangle;
	import flash.geom.ColorTransform;
	import flash.events.MouseEvent;
	import flash.events.TextEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class shapesFreePlay extends MovieClip{
		
		private var shapesMC:MovieClip;
		private var notesMC:MovieClip;
		private var prevClip:MovieClip;
		private var countersCnt:Number = 0;
		private var noteMaskHeight:Number = 0;		
		private var smallClipXPos:Number = 75;
		private var smallClipYPos:Number = 468;
		private var shapeCnt:Number = 0;
		private var shapesXYPosArr:Array = [];
		private var shapesDelXYPosArr:Array = [];
		private var shapeDelAngleArr:Array = [];
		private var colorArr:Array = ["0x009900", "0xED1C24", "0xFFDE00", "0x005FAE"];
		private var myShapesArr:Array = [1,2,3,6,7,8,9,10,11,12,14];
		private var maxChrsArr:Array = [15, 29, 43, 57];
		//private var color = "0xFE9900";
		private var color = colorArr[2];
		private var cnt:Number = 0;
		private var notesCnt:Number = 0;
		private var totalNotes:Number = 30;
		private var mcColorTransform:ColorTransform = new ColorTransform;
		
		public function shapesFreePlay():void{
			shapesMC = new MovieClip;
			addChild(shapesMC);
			addNotes_btn.addEventListener(MouseEvent.CLICK, fnAddNotes);
			notesMC = new MovieClip;
			addChild(notesMC);
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("assets/shapes_free_play.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, fnLoadXML);
			
			delete_btn.addEventListener(MouseEvent.CLICK, fnDeleteShape);
			clockwise_btn.addEventListener(MouseEvent.CLICK, fnRotateShape);
			anitClockwise_btn.addEventListener(MouseEvent.CLICK, fnRotateShape);
			
			larger_btn.addEventListener(MouseEvent.CLICK, fnResizeShape);
			smaller_btn.addEventListener(MouseEvent.CLICK, fnResizeShape);
			for(var i:Number = 0; i < colorArr.length; i++){
				var colorClip:MovieClip = clrPickerMC.getChildByName("clr_" + i + "_mc") as MovieClip;
				colorClip.addEventListener(MouseEvent.CLICK, fnChangeColorCode);
				colorClip.addEventListener(MouseEvent.ROLL_OVER, onColorOver);
				colorClip.addEventListener(MouseEvent.ROLL_OUT, onColorOut);
				colorClip.buttonMode = true;
			}
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
		}
		
		private function onColorOver(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(2);
		}
		
		private function onColorOut(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(1);
		}
		
		//loading XML
		private function fnLoadXML(eve:Event):void{
			var xml:XML = new XML(eve.target.data);
			for(var i:Number = 0; i < xml.shapePosition.pos.length(); i++){
				shapesXYPosArr.push(xml.shapePosition.pos[i].@XY);//pushing xy position in array
			}
			fnDisplaysShapes();
			//fnUpdatedShapeColor();
		}
		
		//adding shapes to the stage
		private function fnDisplaysShapes():void{
			for(var i:Number = 1; i <= myShapesArr.length; i++){
				var clipClass:Class = getDefinitionByName("shape_" + myShapesArr[i-1] + "_mc") as Class;
				var clip:MovieClip = new clipClass;
				addChild(clip);
				clip.name = "shape_" + myShapesArr[i-1] + "_mc";
				clip.width = clip.width * (37/100);
				clip.height = clip.height * (37/100);
				clip.x = smallClipXPos + (clip.width/2);
				clip.y = smallClipYPos;
				clip.mouseChildren = false;
				smallClipXPos = smallClipXPos + clip.width + 18;
				clip.addEventListener(MouseEvent.CLICK, fnAddShapeToStage);
			}
		}
		
		private function fnAddShapeToStage(eve:MouseEvent):void{
			if(prevClip != null){
				prevClip.alpha = 1;
			}
			if(shapeCnt < 15){
				var clipClass:Class = getDefinitionByName(eve.target.name) as Class;
				var clip:MovieClip = new clipClass;
				shapesMC.addChild(clip);
				cnt++;
				clip.name = eve.target.name + "##" + cnt
				if(shapesDelXYPosArr.length == 0){
					clip.x = Number(shapesXYPosArr[shapeCnt].split("_")[0]);
					clip.y = Number(shapesXYPosArr[shapeCnt].split("_")[1]);
				}else{
					clip.x = Number(shapesDelXYPosArr[0].split("_")[0]);
					clip.y = Number(shapesDelXYPosArr[0].split("_")[1]);
					clip.rotation = shapeDelAngleArr[0];
					shapeDelAngleArr.shift();
					shapesDelXYPosArr.shift();
				}
				mcColorTransform = clip.transform.colorTransform;
				mcColorTransform.color = color;	
				clip.bg.transform.colorTransform = mcColorTransform;
				clip.alpha = .7;
				prevClip = clip;
				clip.addEventListener(MouseEvent.MOUSE_DOWN, fnShapeMouseDown);
				clip.mouseChildren = false;
				clip.doubleClickEnabled = true;
				clip.addEventListener(MouseEvent.DOUBLE_CLICK, fnDeleteShape);
				shapeCnt++;
			}
		}
		
		//shape mouse down event
		private function fnShapeMouseDown(eve:MouseEvent):void{			
			var clip:MovieClip = eve.target as MovieClip;
			clip.startDrag(false, new Rectangle(60, 60, 630, 400));
			clip.addEventListener(MouseEvent.MOUSE_UP, fnShapeMouseUp);
		}
		
		private function fnShapeMouseUp(eve:MouseEvent):void{
			if(prevClip != null){
				prevClip.alpha = 1;
			}
			var clip:MovieClip = eve.target as MovieClip;
			clip.alpha = .7;
			prevClip = clip;
			clip.stopDrag();
			clip.removeEventListener(MouseEvent.MOUSE_UP, fnShapeMouseUp);
		}
		
		//deletes the shape when delete button is clicked
		private function fnDeleteShape(eve:MouseEvent):void{
			if(prevClip != null){
				shapesMC.removeChild(prevClip);
				shapesDelXYPosArr.push(prevClip.x + "_" + prevClip.y);
				shapeDelAngleArr.push(prevClip.rotation);
				prevClip = null;
				shapeCnt--;
			}
		}
		
		//rotates shape in clockwise/anticlockwise, based on button clicked
		private function fnRotateShape(eve:MouseEvent):void{
			if(prevClip != null){
				var angle:Number = prevClip.rotation;
				if(eve.target.name == "clockwise_btn"){
					prevClip.rotation = angle + 35;
				}else{
					prevClip.rotation = angle - 35;
				}
			}
			
		}
		
		//resize shape based on button clicked
		private function fnResizeShape(eve:MouseEvent):void{
			var refClipClass:Class = getDefinitionByName(prevClip.name.split("##")[0]) as Class;
			var refClip:MovieClip = new refClipClass;
			if(eve.target.name == "larger_btn"){
				/*if(prevClip.width <= (refClip.width * (300/100))){
					prevClip.width = prevClip.width * (150/100);
					prevClip.height = prevClip.height * (150/100);
				}*/   
				if(prevClip.scaleX <= (refClip.scaleX * (300/100))){
					prevClip.scaleX = prevClip.scaleX * (150/100);
					prevClip.scaleY = prevClip.scaleY * (150/100);
				}
			}else{
				/*if(prevClip.width  > refClip.width){
					prevClip.width = prevClip.width / (150/100);
					prevClip.height = prevClip.height / (150/100);
				}*/
				if(prevClip.scaleX > (refClip.scaleX)){
					prevClip.scaleX = prevClip.scaleX / (150/100);
					prevClip.scaleY = prevClip.scaleY / (150/100);
				}
			}
		}
		
		//Changes the grid color with the selected color
		private function fnChangeColorCode(eve:MouseEvent):void{
			var btnColor:Array = eve.target.name.split("_");
			color = uint(colorArr[btnColor[1]]);			
			//clrPickerMC.highlightMC.x = eve.target.x;
			//clrPickerMC.highlightMC.y = eve.target.y;
			for(var i:Number = 0; i < colorArr.length; i++){
				var colorClip:MovieClip = clrPickerMC.getChildByName("clr_" + i + "_mc") as MovieClip;
				colorClip.addEventListener(MouseEvent.ROLL_OVER, onColorOver);
				colorClip.addEventListener(MouseEvent.ROLL_OUT, onColorOut);
				colorClip.buttonMode = true;
				colorClip.mouseEnabled = true;
				colorClip.gotoAndStop(1);
			}
			colorClip.removeEventListener(MouseEvent.ROLL_OVER, onColorOver);
			colorClip.removeEventListener(MouseEvent.ROLL_OUT, onColorOut);
			colorClip.buttonMode = false;
			eve.target.mouseEnabled = false;
			eve.target.gotoAndStop(3);
			fnUpdatedShapeColor();
		}
		
		private function fnUpdatedShapeColor():void{
			for(var i:Number = 1; i <= myShapesArr.length; i++){
				var clip:MovieClip = getChildByName("shape_" + myShapesArr[i-1] + "_mc") as MovieClip;
				mcColorTransform = clip.transform.colorTransform;
				mcColorTransform.color = color;	
				clip.bg.transform.colorTransform = mcColorTransform;
			}
			if(prevClip != null){//changes the color of current shape
				mcColorTransform = prevClip.transform.colorTransform;
				mcColorTransform.color = color;	
				//prevClip.bg.transform.colorTransform = mcColorTransform;
			}
		}
		
		//notes
		private function fnAddNotes(eve:MouseEvent):void{
			notesCnt++;
			if(notesCnt<=totalNotes){
				var noteMC:notes_mc = new notes_mc;
				notesMC.addChild(noteMC);
				noteMC.name = "mynotesMC"+notesCnt;
				/*noteMC.x = mouseX - (noteMC.width/2);
				noteMC.y = mouseY;
				//trace("GANESH = "+(15*((notesCnt-(Math.floor(notesCnt/10)*10))-1)));
				var placeFound = 0;
				if(notesCnt>1){
					for(var i=1; i<=(notesCnt-1); i++){
						trace("ival = "+i);
						var myNote = notesMC.getChildByName("mynotesMC"+i);
						trace("myNote = "+myNote);
						if((i%10)==0){
							var Xval = 10+(200*Math.floor(i/10))+(15*((10)-1))-200;
							var Yval = 340-(15*((10)-1));
						}else{
							Xval = 10+(200*Math.floor(i/10))+(15*((i-(Math.floor(i/10)*10))-1));
							Yval = 340-(15*((i-(Math.floor(i/10)*10))-1));
						}
						if(myNote.x!=Xval && myNote.y!=Yval){
							placeFound = i;
							break;
						}
					}
				}
				if(placeFound!=0){
					Xval = 10+(200*Math.floor(placeFound/10))+(15*((placeFound-(Math.floor(placeFound/10)*10))-1));
					Yval = 340-(15*((placeFound-(Math.floor(placeFound/10)*10))-1));
					noteMC.x = Xval;
					noteMC.y = Yval;
				}else{
					if((notesCnt%10)==0){
						noteMC.x = 10+(200*Math.floor(notesCnt/10))+(15*((10)-1))-200;
						noteMC.y = 340-(15*((10)-1));
					}else{
						noteMC.x = 10+(200*Math.floor(notesCnt/10))+(15*((notesCnt-(Math.floor(notesCnt/10)*10))-1));
						noteMC.y = 340-(15*((notesCnt-(Math.floor(notesCnt/10)*10))-1));
					}
				}*/
				
				if((notesCnt%10)==0){
					noteMC.x = 10+(200*Math.floor(notesCnt/10))+(15*((10)-1))-200;
					noteMC.y = 340-(15*((10)-1));
				}else{
					noteMC.x = 10+(200*Math.floor(notesCnt/10))+(15*((notesCnt-(Math.floor(notesCnt/10)*10))-1));
					noteMC.y = 340-(15*((notesCnt-(Math.floor(notesCnt/10)*10))-1));
				}
					
				noteMC.inputTxt.maxChars = maxChrsArr[0];
				noteMC.drag_mc.mouseChildren = false;
				noteMC.drag_mc.buttonMode = true;
				noteMC.drag_mc.addEventListener(MouseEvent.MOUSE_DOWN,fnDragNote);			
				noteMC.upArrow_mc.addEventListener(MouseEvent.CLICK, fnResizeNote);
				noteMC.downArrow_mc.addEventListener(MouseEvent.CLICK, fnResizeNote);			
				noteMC.closeBtn.addEventListener(MouseEvent.CLICK, fnCloseNote);
				noteMC.inputTxt.addEventListener(TextEvent.TEXT_INPUT, fnKeyboardReturnHandler);
				noteMaskHeight = noteMC.mask_mc.height;
			}else{
				notesCnt--;
			}
		}
		
		//drags notes
		private function fnDragNote(eve:MouseEvent):void{
			var noteClip:MovieClip = eve.target.parent as MovieClip;
			noteClip.startDrag(false,new Rectangle(0,0,760-noteClip.width,340));
			noteClip.addEventListener(MouseEvent.MOUSE_UP, fnStopDragNote);
		}
		
		//stops drag and removes events
		private function fnStopDragNote(eve:MouseEvent):void{
			var noteClip:MovieClip = eve.target.parent as MovieClip;
			noteClip.stopDrag();
			noteClip.removeEventListener(MouseEvent.MOUSE_UP, fnStopDragNote);
		}
		
		//resizing notes based on arrow clicked
		private function fnResizeNote(eve:MouseEvent):void{
			var noteClip:MovieClip = eve.target.parent as MovieClip;
			var maxChar:Number = 0;
			if(eve.target.name == "upArrow_mc"){
				if(noteClip.mask_mc.height > noteMaskHeight){
					noteClip.mask_mc.height = noteClip.mask_mc.height - 21;
					maxChar = fnCurrentMaxChar(noteClip.inputTxt);
					noteClip.inputTxt.maxChars = maxChrsArr[maxChar - 1];
				}
			}else{
				if(noteClip.mask_mc.height < (noteClip.noteBg_mc.height - 21)){
					noteClip.mask_mc.height = noteClip.mask_mc.height + 21;
					maxChar = fnCurrentMaxChar(noteClip.inputTxt);
					noteClip.inputTxt.maxChars = maxChrsArr[maxChar + 1];
				}
			}
			noteClip.bottomClip_mc.y = noteClip.mask_mc.y + noteClip.mask_mc.height;			
		}
		
		//finding current max characters from array
		private function fnCurrentMaxChar(txt:TextField):Number{
			for(var i:Number = 0; i < maxChrsArr.length; i++){
				if(txt.maxChars == maxChrsArr[i]){
					return i;
					break;
				}
			}
			return 0;
		}
		
		//close notes
		private function fnCloseNote(eve:MouseEvent):void{
			var noteClip:MovieClip = eve.target.parent as MovieClip;
			notesMC.removeChild(noteClip);
			noteClip.inputTxt.removeEventListener(TextEvent.TEXT_INPUT, fnKeyboardReturnHandler);
			notesCnt--;
		}
		
		//restricting enter key in notes
		private function fnKeyboardReturnHandler(evt:TextEvent):void{
			if  (evt.text == "\n"){
				evt.preventDefault();
			}
		}
		
		private function reset(eve:MouseEvent):void{
			RemoveChildOf(shapesMC);
			RemoveChildOf(notesMC);
			notesCnt = 0;
			color = colorArr[2];
			//clrPickerMC.highlightMC.x = clrPickerMC.clr_2_mc.x;
			//clrPickerMC.highlightMC.y = clrPickerMC.clr_2_mc.y;
			for(var i:Number = 0; i < colorArr.length; i++){
				var colorClip:MovieClip = clrPickerMC.getChildByName("clr_" + i + "_mc") as MovieClip;
				colorClip.addEventListener(MouseEvent.ROLL_OVER, onColorOver);
				colorClip.addEventListener(MouseEvent.ROLL_OUT, onColorOut);
				colorClip.buttonMode = true;
				colorClip.mouseEnabled = true;
				colorClip.gotoAndStop(1);
			}
			clrPickerMC.clr_2_mc.removeEventListener(MouseEvent.ROLL_OVER, onColorOver);
			clrPickerMC.clr_2_mc.removeEventListener(MouseEvent.ROLL_OUT, onColorOut);
			clrPickerMC.clr_2_mc.buttonMode = false;
			clrPickerMC.clr_2_mc.mouseEnabled = false;
			clrPickerMC.clr_2_mc.gotoAndStop(3);
			fnUpdatedShapeColor();
			cnt = 0;
			shapeCnt = 0;
			shapesDelXYPosArr = [];
			prevClip = null;
		}
		
		//Removes children of reference movie clip
		private function RemoveChildOf(Reference:MovieClip):void{
			for(var s:int=Reference.numChildren-1;s>=0;s--){
				Reference.removeChild(Reference.getChildAt(s));
			}			
		}
	}
}