﻿package com{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.utils.getDefinitionByName;
	
	public class Coins extends MovieClip{
		private var dataXml:XML;
		private var ausCoinsMc:MovieClip;
		private var forgCoinsMc:MovieClip;
		private var coinsMc:MovieClip;
		private var coinCnt = 0;
		private var dragObj;
		
		public function Coins(){
			ausCoinsMc = new MovieClip();
			addChild(ausCoinsMc);
			forgCoinsMc = new MovieClip();
			addChild(forgCoinsMc);
			forgCoinsMc.visible = false;
			coinsMc = new MovieClip();
			addChild(coinsMc);
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("xml/coins.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, fnLoadXML);
		}
		
		private function fnLoadXML(eve:Event):void{
			dataXml = new XML(eve.target.data);
			for(var i=1; i<=dataXml.australianCoins.pos.length(); i++){
				var myClassNam = dataXml.australianCoins.pos[i-1].@classNam;
				var clipClass:Class = getDefinitionByName(myClassNam) as Class;
				var clip:MovieClip = new clipClass;
				ausCoinsMc.addChild(clip);
				clip.name = myClassNam;
				clip.Num = i;
				clip.x = Number((dataXml.australianCoins.pos[i-1].@XY).split("_")[0]);
				clip.y = Number((dataXml.australianCoins.pos[i-1].@XY).split("_")[1]);
				clip.mouseChildren = false;
				clip.addEventListener(MouseEvent.ROLL_OVER, onOver);
				clip.addEventListener(MouseEvent.ROLL_OUT, onOut);
				clip.addEventListener(MouseEvent.MOUSE_DOWN, onMoneyDown);
			}
			for(i=1; i<=dataXml.foreignCoins.pos.length(); i++){
				myClassNam = dataXml.foreignCoins.pos[i-1].@classNam;
				clipClass = getDefinitionByName(myClassNam) as Class;
				clip = new clipClass;
				forgCoinsMc.addChild(clip);
				clip.name = myClassNam;
				clip.Num = i;
				clip.x = Number((dataXml.foreignCoins.pos[i-1].@XY).split("_")[0]);
				clip.y = Number((dataXml.foreignCoins.pos[i-1].@XY).split("_")[1]);
				clip.mouseChildren = false;
				clip.addEventListener(MouseEvent.ROLL_OVER, onOver);
				clip.addEventListener(MouseEvent.ROLL_OUT, onOut);
				clip.addEventListener(MouseEvent.MOUSE_DOWN, onMoneyDown);
			}
			addBtnListeners();
		}
		private function onOver(e:MouseEvent)
		{
			e.currentTarget.gotoAndStop(2)
		}
		private function onOut(e:MouseEvent)
		{
			e.currentTarget.gotoAndStop(1)	
		}
		private function addBtnListeners(){
			hide_coins.visible = false;
			show_coins.addEventListener(MouseEvent.CLICK, showHideCoins);
			hide_coins.addEventListener(MouseEvent.CLICK, showHideCoins);
			reset_btn.addEventListener(MouseEvent.CLICK, resetFunc);
		}
		
		private function resetFunc(obj:MouseEvent){
			removeCoins();
			forgCoinsMc.visible = false;
			show_coins.visible = true;
			hide_coins.visible = false;
		}
		
		private function showHideCoins(obj:MouseEvent){
			removeCoins();
			if(show_coins.visible==true){
				forgCoinsMc.visible = true;
				show_coins.visible = false;
				hide_coins.visible = true;
			}else{
				forgCoinsMc.visible = false;
				show_coins.visible = true;
				hide_coins.visible = false;
			}
		}
		
		private function removeCoins(){
			coinCnt = 0;
			while(coinsMc.numChildren){
				coinsMc.removeChildAt(0);
			}
		}
		
		private function onMoneyDown(obj:MouseEvent){
			coinCnt++;
			var clipClass:Class = getDefinitionByName(obj.target.name) as Class;
			var clip:MovieClip = new clipClass();
			clip.name = "coin"+coinCnt;
			coinsMc.addChild(clip);
			clip.x = mouseX;
			clip.y = mouseY;
			clip.doubleClickEnabled = true
			clip.addEventListener(MouseEvent.DOUBLE_CLICK,removeCurrentCoins)
			clip.addEventListener(MouseEvent.MOUSE_DOWN, dragCoin);
			clip.addEventListener(MouseEvent.MOUSE_UP, dropCoin);
			clip.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
		}
		private function removeCurrentCoins(e:MouseEvent)
		{
			var targetMc = e.currentTarget			
			coinsMc.removeChild(targetMc);
		}
		private function dragCoin(obj:MouseEvent){
			dragObj = obj.currentTarget;
			dragObj.startDrag(false, new Rectangle(0, 10, 760, 500));
			dragObj.parent.stage.addEventListener(MouseEvent.MOUSE_UP, dropCoin);
		}
		
		private function dropCoin(obj:MouseEvent){
			dragObj.stopDrag();
			dragObj.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, dropCoin);
		}
	}
}