﻿package com{	
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.display.Stage;
	
	public class HundredsChart extends MovieClip{
		
		private var gridBoxX:Number;
		private var gridBoxY:Number;
		private var gridsMC:MovieClip;		
		private var gridBox:gridBoxMc;
		private var X:Number = 10;
		private var Y:Number = 10;
		private var count:Number = 0;
		private var mcColorTransform:ColorTransform;
		private var color:uint = 0x009900;
		private var XMLData:XML;
		private var pointerCntByMC:pointerCountByMC;
		private var textEntMC:textEnterMC;
		private var clrPickerMC:colorPickerMC;
		private var shwMC:showNumersMc;
		private var hideMC:hideNumersMc;
		private var startIndex:Number = 0;
		private var endIndex:Number = 0;
		private var pointerFlag:Boolean = false;
		private var gridColor:Array = new Array();
		private var colorPicked:String = "green";
		private var cntByClick:Boolean = false;
		private var myCountStartIndex:Number = 0;
		private var counterCnt:Number = 0;
		
		public function HundredsChart(){
			
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("assets/hundredcards.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, fnLoadXML)
		}
		
		//loading xml
		private function fnLoadXML(eve:Event):void{
			stage.stageFocusRect = false; //To disable yellow highlight around movieclips and buttons in tab press
			XMLData = new XML(eve.target.data);
			gridBoxX = XMLData.gridPosition.@X;
			gridBoxY = XMLData.gridPosition.@Y;
			startIndex = 1;
			endIndex = 10;
			fnGenerateGrids();
			fnAddButtons();			
		}
		
		//adding buttons,events for the buttons and aligning buttons
		private function fnAddButtons():void{			
			pointerCntByMC = new pointerCountByMC;
			addChild(pointerCntByMC);
			pointerCntByMC.x = XMLData.buttonsPosition.pointerCountBy.@X;
			pointerCntByMC.y = XMLData.buttonsPosition.pointerCountBy.@Y;
			pointerCntByMC.name = "pointerCntByMC";
			btnEnable(pointerCntByMC.pointerBtn);
			btnEnable(pointerCntByMC.countByBtn);
			pointerCntByMC.countByBtn.mouseChildren = false;
			pointerCntByMC.countByBtn.addEventListener(MouseEvent.CLICK, fnShowTextEnterMC);
			pointerCntByMC.pointerBtn.addEventListener(MouseEvent.CLICK, fnAttachPointer);
			pointerCntByMC.countByBtn.mouseEnabled = false;
			
			textEntMC = new textEnterMC;
			addChild(textEntMC);
			textEntMC.x = XMLData.buttonsPosition.enter.@X;
			textEntMC.y = XMLData.buttonsPosition.enter.@Y;
			textEntMC.name = "textEntMC";
			btnEnable(textEntMC.enterBtn);
			textEntMC.enterBtn.mouseChildren = false;
			textEntMC.enterBtn.addEventListener(MouseEvent.CLICK, fnDisplayMultiples);
			textEntMC.visible = false;
			
			clrPickerMC = new colorPickerMC;
			addChild(clrPickerMC);
			clrPickerMC.x = XMLData.buttonsPosition.colorPalette.@X;
			clrPickerMC.y = XMLData.buttonsPosition.colorPalette.@Y;
			clrPickerMC.name = "clrPickerMC";
			clrPickerMC.green_mc.buttonMode = true;
			clrPickerMC.red_mc.buttonMode = true;
			clrPickerMC.blue_mc.buttonMode = true;
			clrPickerMC.yellow_mc.buttonMode = true;
			clrPickerMC.green_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.red_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.blue_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.yellow_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.green_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.red_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.blue_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.yellow_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.green_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			clrPickerMC.red_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			clrPickerMC.blue_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			clrPickerMC.yellow_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			
			clrPickerMC.green_mc.removeEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.green_mc.removeEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.green_mc.buttonMode = false;
			clrPickerMC.green_mc.mouseEnabled = false;
			clrPickerMC.green_mc.gotoAndStop(3);
			/*shwMC = new showMC;
			addChild(shwMC);
			shwMC.x = XMLData.buttonsPosition.show.@X;
			shwMC.y = XMLData.buttonsPosition.show.@Y;
			shwMC.name = "shwMC";
			btnEnable(shwMC.show_0_99_Btn);
			btnEnable(shwMC.show_1_100_Btn);
			shwMC.show_1_100_Btn.visible = false;
			shwMC.show_0_99_Btn.addEventListener(MouseEvent.CLICK, fnChangeNumbers);
			shwMC.show_1_100_Btn.addEventListener(MouseEvent.CLICK, fnChangeNumbers);*/
			
			shwMC = new showNumersMc;
			addChild(shwMC);
			shwMC.x = XMLData.buttonsPosition.show.@X;
			shwMC.y = XMLData.buttonsPosition.show.@Y;
			shwMC.name = "shwMC";
			shwMC.mouseChildren = false;
			shwMC.buttonMode = true;
			shwMC.addEventListener(MouseEvent.CLICK, showAllNumbers);
			
			hideMC = new hideNumersMc;
			addChild(hideMC);
			hideMC.x = XMLData.buttonsPosition.hide.@X;
			hideMC.y = XMLData.buttonsPosition.hide.@Y;
			hideMC.name = "shwMC";
			hideMC.mouseChildren = false;
			hideMC.buttonMode = true;
			hideMC.addEventListener(MouseEvent.CLICK, hideAllNumbers);
			hideMC.visible = false;
			
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
		}
		
		private function onBtnOver(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(2);
		}
		
		private function onBtnOut(obj:MouseEvent){
			obj.currentTarget.gotoAndStop(1);
		}
		
		private function showAllNumbers(obj:MouseEvent){
			var myCount = 1;
			for(var i:Number = startIndex; i <= endIndex; i++){				
				for(var j:Number = startIndex; j <= endIndex; j++){
					var myGridBox = gridsMC.getChildByName("gridBox_" + myCount);
					myGridBox.numberTxt.text = myGridBox.numCount;
					myCount++;
				}
			}
			hideMC.visible = true;
			shwMC.visible = false;
		}
		
		private function hideAllNumbers(obj:MouseEvent){
			var myCount = 1;
			for(var i:Number = startIndex; i <= endIndex; i++){				
				for(var j:Number = startIndex; j <= endIndex; j++){
					var myGridBox = gridsMC.getChildByName("gridBox_" + myCount);
					if((i==startIndex && j==startIndex) || (i==endIndex && j==endIndex)){
						//myGridBox.numberTxt.text = "";
					}else{
						myGridBox.numberTxt.text = "";
					}
					myCount++;
				}
			}
			hideMC.visible = false;
			shwMC.visible = true;
		}
		
		private function reset(eve:MouseEvent):void{
			/*var btnName:String;
			if(shwMC.show_0_99_Btn.visible){
				btnName = "show_1_100_Btn";
			}else{
				btnName = "show_0_99_Btn";
			}
			
			var btnNameArr:Array = btnName.split("_");
			startIndex = Number(btnNameArr[1]);
			endIndex = Math.floor(Number(btnNameArr[2])/10);*/
			fnRemoveGrids();
			startIndex = 1;
			endIndex = 10;
			resetAll();						
		}
		private function fnAttachPointer(eve:MouseEvent = null):void{
			if(pointerFlag){
				if(getChildByName("bg") != null){
					removeChild(getChildByName("bg"));
					removeChild(getChildByName("pointerMC"));					
				}
				pointerFlag = false;
			}else{
				var pointerMC:pointer_mc  = new pointer_mc;
				pointerMC  = new pointer_mc;
				addChild(pointerMC);
				pointerMC.name = "pointerMC";
				pointerMC.startDrag(true);
				pointerMC.mouseChildren = false;
				pointerMC.mouseEnabled  = false;
				pointerFlag = true;
				//add disable bg for grids
				var bg:MovieClip = new MovieClip();
				addChild(bg);
				bg.name = "bg";
				bg.graphics.lineStyle(3,0xffffff,0);
				bg.graphics.beginFill(0x0000FF,0);
				bg.graphics.drawRect(XMLData.gridPosition.@X,XMLData.gridPosition.@Y, gridsMC.width + 10,gridsMC.height + 10);
				bg.graphics.endFill();
			}
		}
		
		//Hide/Unhide textinput and enter button
		private function fnShowTextEnterMC(eve:MouseEvent):void{
			if(textEntMC.visible){
				textEntMC.visible = false;
			}else{
				textEntMC.visible = true;
			}
		}
		//Displays grid from 0-99 or 1-100 based on button clicked
		private function fnChangeNumbers(eve:MouseEvent):void{
			if(shwMC.show_0_99_Btn.visible){
				shwMC.show_0_99_Btn.visible = false;
				shwMC.show_1_100_Btn.visible = true;
			}else{
				shwMC.show_0_99_Btn.visible = true;
				shwMC.show_1_100_Btn.visible = false;
			}
			fnRemoveGrids();
			var btnName:Array = eve.target.name.split("_");
			startIndex = Number(btnName[1]);
			endIndex = Math.floor(Number(btnName[2])/10);
			resetAll();
		}
		
		private function resetAll():void{	
			counterCnt = 0;
			pointerCntByMC.countByBtn.mouseEnabled = false;
			textEntMC.enterBtn.mouseEnabled = true;
			count = 0;
			X = 10;
			Y = 10;
			pointerFlag = true;
			color = 0x009900;
			colorPicked = "green";
			//clrPickerMC.highlightMC.x = 50.2;
			//clrPickerMC.highlightMC.y = 6.1;
			gridColor = [];
			textEntMC.visible = false;
			fnAttachPointer();
			fnGenerateGrids();
		}
		
		//removes main clip and child clips
		private function fnRemoveGrids():void{
			for(var i:Number = startIndex; i <= gridsMC.numChildren; i++){
				gridsMC.removeChild(gridsMC.getChildByName("gridBox_" + i));
			}
			removeChild(gridsMC);
		}
		
		//Changes the grid color with the selected color
		private function fnChangeGridColorCode(eve:MouseEvent):void{
			var btnColor:Array = eve.target.name.split("_");
			if(btnColor[0] == "red"){
				color = 0xED1C24;
				colorPicked = "red";
			}else if(btnColor[0] == "blue"){
				color = 0x005FAE;
				colorPicked = "blue";
			}else if(btnColor[0] == "green"){
				color = 0x009900;
				colorPicked = "green";
			}else{
				color = 0xFFDE00;
				colorPicked = "yellow";
			}
			//clrPickerMC.highlightMC.x = eve.target.x;
			//clrPickerMC.highlightMC.y = eve.target.y;
			//trace("readd");
			clrPickerMC.green_mc.buttonMode = true;
			clrPickerMC.red_mc.buttonMode = true;
			clrPickerMC.blue_mc.buttonMode = true;
			clrPickerMC.yellow_mc.buttonMode = true;
			clrPickerMC.green_mc.mouseEnabled = true;
			clrPickerMC.red_mc.mouseEnabled = true;
			clrPickerMC.blue_mc.mouseEnabled = true;
			clrPickerMC.yellow_mc.mouseEnabled = true;
			clrPickerMC.green_mc.gotoAndStop(1);
			clrPickerMC.red_mc.gotoAndStop(1);
			clrPickerMC.blue_mc.gotoAndStop(1);
			clrPickerMC.yellow_mc.gotoAndStop(1);
			clrPickerMC.green_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.red_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.blue_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.yellow_mc.addEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			clrPickerMC.green_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.red_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.blue_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			clrPickerMC.yellow_mc.addEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			
			eve.currentTarget.removeEventListener(MouseEvent.ROLL_OVER, onBtnOver);
			eve.currentTarget.removeEventListener(MouseEvent.ROLL_OUT, onBtnOut);
			eve.currentTarget.buttonMode = false;
			eve.currentTarget.mouseEnabled = false;
			eve.currentTarget.gotoAndStop(3);
		}
		
		//Adding mousechildren and buttonmode for movie clip
		private function btnEnable(btn:*):void{
			btn.mouseChildren = false;
			btn.buttonMode = true;
		}
		
		//Generates grid 
		private function fnGenerateGrids():void{
			gridsMC = new MovieClip();
			addChild(gridsMC);
			count = startIndex;
			for(var i:Number = startIndex; i <= endIndex; i++){				
				for(var j:Number = startIndex; j <= endIndex; j++){
					gridBox = new gridBoxMc;
					gridsMC.addChild(gridBox);					
					gridBox.name = "gridBox_" + count;
					gridColor.push(" ");
					gridBox.doubleClickEnabled = true;
					gridBox.addEventListener(MouseEvent.DOUBLE_CLICK, showHideNumbers);
					gridBox.addEventListener(MouseEvent.CLICK, fnChngClickGridColor);
					gridBox.mouseChildren = false;
					gridBox.buttonMode = true;
					if((i==startIndex && j==startIndex) || (i==endIndex && j==endIndex)){
						gridBox.numberTxt.text = String(count);
					}else{
						gridBox.numberTxt.text = "";
					}
					gridBox.numCount = String(count);
					if((i == startIndex && j == startIndex) || (j == startIndex)){
						if(i == startIndex && j == startIndex){
							gridBox.x = X;
							gridBox.y = Y;
						}else{
							gridBox.x = 10;
							gridBox.y = Y;
						}
						
					}else{
						X = X + gridBox.width - 1;
						gridBox.x = X;
						gridBox.y = Y;
					}
					count++;
				}
				Y = Y + gridBox.height - 1
				X = 10;
			}
			count--;
			gridsMC.x = gridBoxX;
			gridsMC.y = gridBoxY;
		}
		
		private function showHideNumbers(obj:MouseEvent){
			var myGridBox = obj.currentTarget;
			if(myGridBox.numberTxt.text == ""){
				myGridBox.numberTxt.text = myGridBox.numCount;
			}else{
				myGridBox.numberTxt.text = "";
			}
		}
		
		//change grid box color of selected box
		private function fnChngClickGridColor(eve:MouseEvent):void{
			pointerCntByMC.countByBtn.mouseEnabled = true;
			myCountStartIndex = eve.target.numCount;
			var clipName:String = eve.target.name;
			fnChangeClipColor(clipName.split("_")[1]);
		}
		
		//Highlight color of multiples of text entered
		private function fnDisplayMultiples(eve:MouseEvent):void{
			cntByClick = true;
			var multipleValue:Number = textEntMC.countTextMC.counterTxt.text;
			//trace("myCountStartIndex = "+myCountStartIndex);
			for(var i:Number = myCountStartIndex; i <= count; i++){
				var myNum = (i-(myCountStartIndex-1));
				if(myNum%multipleValue == 0){
					if(myNum != 0){
						fnChangeClipColor((myNum+myCountStartIndex));
					}
				}
			}
			if(++counterCnt==4){
				textEntMC.enterBtn.mouseEnabled = false;
			}
		}
		
		//Change color of grid
		private function fnChangeClipColor(index:Number):void{
			var clip:MovieClip = new MovieClip();
			clip = gridsMC.getChildByName("gridBox_" + index) as MovieClip;
			if(gridColor[index-1] == " "){
				gridColor[index-1] = colorPicked;
				if(colorPicked == "yellow"){
					color = 0xFFDE00;
				}else if(colorPicked == "red"){
					color = 0xED1C24;
				}else if(colorPicked == "green"){
					color = 0x009900;
				}else{
					color = 0x005FAE;
				}
			}else{
				if((gridColor[index-1] == "yellow" && colorPicked == "blue") || (gridColor[index-1] == "blue" && colorPicked == "yellow")){
					color = 0x339933;
					gridColor[index-1] = "green";
				}else if(gridColor[index-1] == "green" && colorPicked == "blue"){
					color = 0x996600;
					gridColor[index-1] = "brown";
				}else if((gridColor[index-1] == "red" && colorPicked == "yellow") || (gridColor[index-1] == "yellow" && colorPicked == "red")){
					color = 0xff9900;
					gridColor[index-1] = "orange";
				}else if((gridColor[index-1] == "red" && colorPicked == "blue") || (gridColor[index-1] == "blue" && colorPicked == "red")){
					color = 0x9900cc;
					gridColor[index-1] = "lavender";
				}else if((gridColor[index-1] == "orange" && colorPicked == "yellow") || (gridColor[index-1] == "orange" && colorPicked == "red") || (gridColor[index-1] == "orange" && colorPicked == "blue") || (gridColor[index-1] == "lavender" && colorPicked == "yellow") || (gridColor[index-1] == "lavender" && colorPicked == "red") || (gridColor[index-1] == "lavender" && colorPicked == "blue")){
					color = 0x996600;
					gridColor[index-1] = "brown";
				}else if((gridColor[index-1] == "brown" && colorPicked == "yellow") || (gridColor[index-1] == "brown" && colorPicked == "red") || (gridColor[index-1] == "brown" && colorPicked == "blue")){
					if(colorPicked == "yellow"){
						color = 0xFFDE00;
					}else if(colorPicked == "blue"){
						color = 0x005FAE;
					}else if(colorPicked == "green"){
						color = 0x009900;
					}else{
						color = 0xED1C24;
					}
					//color = 0xff9900;
					gridColor[index-1] = colorPicked;
				}else if((gridColor[index-1] == "yellow" && colorPicked == "yellow") || (gridColor[index-1] == "red" && colorPicked == "red") || (gridColor[index-1] == "blue" && colorPicked == "blue") || (gridColor[index-1] == "green" && colorPicked == "green")){
					if(!cntByClick){
						cntByClick = false;
						color = 0xffffff;
						gridColor[index-1] = " ";
					}
				}
			}			
			mcColorTransform = clip.transform.colorTransform;
			mcColorTransform.color = color;	
			clip.gridBoxBgMC.transform.colorTransform = mcColorTransform;
		}
		
		
	}
}