﻿package com{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.utils.getDefinitionByName;
	
	public class Counters extends MovieClip{
		private var xmlLoader:URLLoader;
		private var myURLRequest:URLRequest;
		private var dataXml:XML;
		private var rad:Number=0;
		private var counterLineThick = 0;
		private var counterLineColor = "";
		private var counterFillColor = "";
		private var myTextBox;
		private var myCounterNum = 0;
		private var totalCounter = 0;
		private var dragObj;
		
		public function Counters(){
			xmlLoader = new URLLoader();
			myURLRequest = new URLRequest("xml/confiq.xml");
			xmlLoader.load(myURLRequest);
			xmlLoader.addEventListener(Event.COMPLETE, onXmlLoaded);
		}
		
		private function onXmlLoaded(evt:Event){
			dataXml = new XML(evt.target.data);
			var myClassName = dataXml.Textbox.@classNam;
			var myClass:Class = getDefinitionByName(myClassName) as Class;
			myTextBox = new myClass();
			myTextBox.name = "textBox";
			myTextBox.x = dataXml.Textbox.@xpos;
			myTextBox.y = dataXml.Textbox.@ypos;
			trace(myTextBox.x+"  ===  "+myTextBox.y);
			addChild(myTextBox);
			totalCounter = dataXml.Counters.counter.length();
			for(var i=1; i<=totalCounter; i++){
				var myCounter = new MovieClip();
				myCounter.name = "counter"+i;
				var myCircle = new Shape();
				var Xpos = Number(dataXml.Counters.counter[i-1].@xpos);
				var Ypos = Number(dataXml.Counters.counter[i-1].@ypos);
				counterLineThick = Number(dataXml.Counters.counter[i-1].@lineThick);
				counterLineColor = dataXml.Counters.counter[i-1].@lineColor;
				counterFillColor = dataXml.Counters.counter[i-1].@fillColor;
				rad = Number(dataXml.Counters.counter[i-1].@radius);
				myCircle.graphics.beginFill(counterFillColor);
				myCircle.graphics.lineStyle(counterLineThick, counterLineColor, 1);
				myCircle.graphics.drawCircle(0, 0, rad);
				myCircle.graphics.endFill();
				myCircle.x = myCircle.x+(myCircle.width/2);
				myCircle.y = myCircle.y+(myCircle.height/2);
				myCounter.addChild(myCircle);
				myCounter.Num = i;
				myCounter.x = Xpos;
				myCounter.y = Ypos;
				myCounter.buttonMode = true;
				myCounter.cnt = 0;
				myCounter.addEventListener(MouseEvent.CLICK, addCounter);
				addChild(myCounter);
			}
			reset_btn.addEventListener(MouseEvent.CLICK, onResetFunc);
		}
		
		private function onResetFunc(obj:MouseEvent){
			for(var i=1; i<=2; i++){
				var myInputBox = myTextBox.getChildByName("inputTxt"+i);
				myInputBox.text = "";
			}
			if(myCounterNum>0){
				for(i=1; i<=myCounterNum; i++){
					var myCounter = getChildByName("myCounter"+i);
					removeChild(myCounter);
				}
				myCounterNum = 0;
			}
		}
		
		private function addCounter(obj:MouseEvent){
			myCounterNum++;
			var myCounter:MovieClip = duplicateObject(obj.target as MovieClip);
			myCounter.name = "myCounter"+myCounterNum;
			myCounter.Num = myCounterNum;
			var myCount = obj.currentTarget.cnt;
			myCounter.x = obj.currentTarget.x;
			myCounter.y = obj.currentTarget.y-(obj.currentTarget.height+10)-(myCount*10);
			obj.currentTarget.cnt++;
			if(obj.currentTarget.cnt>31){
				myCounter.y = obj.currentTarget.y-(obj.currentTarget.height+10)-(31*10);
			}
			//myCounter.x = dataXml.centerPosition.@xpos;
			//myCounter.y = dataXml.centerPosition.@ypos;
			addChild(myCounter);
			myCounter.buttonMode = true;
			myCounter.addEventListener(MouseEvent.MOUSE_DOWN, dragCounter);
			myCounter.addEventListener(MouseEvent.MOUSE_UP, dropCounter);
		}
		
		private function dragCounter(obj:MouseEvent){
			dragObj = obj.currentTarget;
			dragObj.startDrag(false, new Rectangle(10, 10, 680, 450));
			dragObj.parent.stage.addEventListener(MouseEvent.MOUSE_UP, dropCounter);
		}
		
		private function dropCounter(obj:MouseEvent){
			dragObj.stopDrag();
			dragObj.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, dropCounter);
		}
		
		private function duplicateObject(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height),true,0x00000000);
			bmd.draw(clone);

			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
		
	}
}